freeslot('tol_combat')

G_AddGametype({
	name = "Combat",
	identifier = "combat",
	typeoflevel = TOL_COMBAT|TOL_MATCH,
	rules = GTR_RESPAWNDELAY|GTR_RINGSLINGER|GTR_EMERALDTOKENS|GTR_POWERSTONES|GTR_SPAWNENEMIES|GTR_TIMELIMIT|GTR_SPECTATORS|GTR_DEATHMATCHSTARTS|GTR_NOSPECTATORSPAWN|GTR_SPAWNINVUL,
	rankingtype = GT_MATCH,
	intermissiontype = int_match,
	defaultpointlimit = 0,
	defaulttimelimit = 5,
	headerleftcolor = 35,
	headerrightcolor = 35,
	description = 'Attack your opponents and bring their HP to Zero! Use the roles special abilities to your advantages!'
})

G_AddGametype({
	name = "Team Combat",
	identifier = "teamcombat",
	typeoflevel = TOL_COMBAT|TOL_MATCH,
	rules = GTR_RESPAWNDELAY|GTR_RINGSLINGER|GTR_EMERALDTOKENS|GTR_POWERSTONES|GTR_SPAWNENEMIES|GTR_TEAMS|GTR_TIMELIMIT|GTR_DEATHMATCHSTARTS|GTR_SPECTATORS|GTR_NOSPECTATORSPAWN|GTR_SPAWNINVUL,
	rankingtype = GT_MATCH,
	intermissiontype = int_match,
	defaultpointlimit = 0,
	defaulttimelimit = 5,
	headerleftcolor = 35,
	headerrightcolor = 152,
	description = 'Deal as much damage as possible to turn them into points to your team!'
})

G_AddGametype({
	name = "Combat Lives",
	identifier = "combatlives",
	typeoflevel = TOL_COMBAT|TOL_MATCH,
	rules = GTR_RESPAWNDELAY|GTR_ALLOWEXIT|GTR_LIVES|GTR_RINGSLINGER|GTR_EMERALDTOKENS|GTR_POWERSTONES|GTR_SPAWNENEMIES|GTR_TIMELIMIT|GTR_DEATHMATCHSTARTS|GTR_SPECTATORS|GTR_NOSPECTATORSPAWN|GTR_SPAWNINVUL,
	rankingtype = GT_MATCH,
	intermissiontype = int_match,
	defaultpointlimit = 0,
	defaulttimelimit = 6,
	headerleftcolor = 112,
	headerrightcolor = 112,
	description = 'A battle to death! Last player standing wins!'
})

G_AddGametype({
	name = "Team Combat Lives",
	identifier = "teamcombatlives",
	typeoflevel = TOL_COMBAT|TOL_MATCH,
	rules = GTR_RESPAWNDELAY|GTR_ALLOWEXIT|GTR_LIVES|GTR_TEAMS|GTR_RINGSLINGER|GTR_EMERALDTOKENS|GTR_POWERSTONES|GTR_SPAWNENEMIES|GTR_TIMELIMIT|GTR_DEATHMATCHSTARTS|GTR_SPECTATORS|GTR_NOSPECTATORSPAWN|GTR_SPAWNINVUL,
	rankingtype = GT_MATCH,
	intermissiontype = int_match,
	defaultpointlimit = 0,
	defaulttimelimit = 7,
	headerleftcolor = 73,
	headerrightcolor = 114,
	description = 'Two teams into a fight to death! Better stick with your teammates!'
})

G_AddGametype({
	name = "Combat CTF",
	identifier = "combatctf",
	typeoflevel = TOL_CTF,
	rules = GTR_RESPAWNDELAY|GTR_LIVES|GTR_TEAMS|GTR_TEAMFLAGS|GTR_RINGSLINGER|GTR_EMERALDTOKENS|GTR_POWERSTONES|GTR_SPAWNENEMIES|GTR_TIMELIMIT|GTR_DEATHMATCHSTARTS|GTR_SPECTATORS|GTR_NOSPECTATORSPAWN|GTR_SPAWNINVUL,
	rankingtype = GT_CTF,
	intermissiontype = int_ctf,
	defaultpointlimit = 0,
	defaulttimelimit = 5,
	headerleftcolor = 150,
	headerrightcolor = 36,
	description = 'CTF but with the Combat System!'
})