//Role
addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.combatrole == nil and player.crolechoosing == nil and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combatrole = 0 
			player.crolechoosing = 0
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.combatrole >= 0 and player.crolechoosing >= 0 and not ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combatrole = nil
			player.crolechoosing = nil
		end
	end
end)

//Choosing role
addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.playerstate == PST_LIVE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.crolechoosing = $+1
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.playerstate == PST_LIVE and player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.crolechoosing = $+1
			player.powers[pw_flashing] = 10
			player.mo.momx = 0 --No one can camp you with tornado or repel while
			player.mo.momy = 0 --No one can camp you with tornado or repel while
			player.pflags = $|PF_FULLSTASIS
			if player.cmd.buttons & BT_ATTACK --Ready to go on!
				player.crolechoosing = 16*TICRATE
				player.powers[pw_flashing] = 45
			end
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.weapondelay == 0 and player.combatrole == 0 and ((player.cmd.buttons & BT_WEAPONNEXT) or (player.cmd.sidemove > 0)) and player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combatrole = 1
			player.weapondelay = 20
			S_StartSound(player.mo, sfx_wepchg)
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.weapondelay == 0 and player.combatrole == 0 and ((player.cmd.buttons & BT_WEAPONPREV) or (player.cmd.sidemove < 0)) and player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combatrole = 6
			player.weapondelay = 20
			S_StartSound(player.mo, sfx_wepchg)
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.weapondelay == 0 and player.combatrole == 1 and ((player.cmd.buttons & BT_WEAPONNEXT) or (player.cmd.sidemove > 0)) and player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combatrole = 2
			player.weapondelay = 20
			S_StartSound(player.mo, sfx_wepchg)
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.weapondelay == 0 and player.combatrole == 1 and ((player.cmd.buttons & BT_WEAPONPREV) or (player.cmd.sidemove < 0)) and player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combatrole = 6
			player.weapondelay = 20
			S_StartSound(player.mo, sfx_wepchg)
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.weapondelay == 0 and player.combatrole == 2 and ((player.cmd.buttons & BT_WEAPONNEXT) or (player.cmd.sidemove > 0)) and player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combatrole = 3
			player.weapondelay = 20
			S_StartSound(player.mo, sfx_wepchg)
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.weapondelay == 0 and player.combatrole == 2 and ((player.cmd.buttons & BT_WEAPONPREV) or (player.cmd.sidemove < 0)) and player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combatrole = 1
			player.weapondelay = 20
			S_StartSound(player.mo, sfx_wepchg)
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.weapondelay == 0 and player.combatrole == 3 and ((player.cmd.buttons & BT_WEAPONNEXT) or (player.cmd.sidemove > 0)) and player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combatrole = 4
			player.weapondelay = 20
			S_StartSound(player.mo, sfx_wepchg)
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.weapondelay == 0 and player.combatrole == 3 and ((player.cmd.buttons & BT_WEAPONPREV) or (player.cmd.sidemove < 0)) and player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combatrole = 2
			player.weapondelay = 20
			S_StartSound(player.mo, sfx_wepchg)
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.weapondelay == 0 and player.combatrole == 4 and ((player.cmd.buttons & BT_WEAPONNEXT) or (player.cmd.sidemove > 0)) and player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combatrole = 5
			player.weapondelay = 20
			S_StartSound(player.mo, sfx_wepchg)
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.weapondelay == 0 and player.combatrole == 4 and ((player.cmd.buttons & BT_WEAPONPREV) or (player.cmd.sidemove < 0)) and player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combatrole = 3
			player.weapondelay = 20
			S_StartSound(player.mo, sfx_wepchg)
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.weapondelay == 0 and player.combatrole == 5 and ((player.cmd.buttons & BT_WEAPONNEXT) or (player.cmd.sidemove > 0)) and player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combatrole = 6
			player.weapondelay = 20
			S_StartSound(player.mo, sfx_wepchg)
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.weapondelay == 0 and player.combatrole == 5 and ((player.cmd.buttons & BT_WEAPONPREV) or (player.cmd.sidemove < 0)) and player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combatrole = 4
			player.weapondelay = 20
			S_StartSound(player.mo, sfx_wepchg)
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.weapondelay == 0 and player.combatrole == 6 and ((player.cmd.buttons & BT_WEAPONNEXT) or (player.cmd.sidemove > 0)) and player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combatrole = 1
			player.weapondelay = 20
			S_StartSound(player.mo, sfx_wepchg)
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.weapondelay == 0 and player.combatrole == 6 and ((player.cmd.buttons & BT_WEAPONPREV) or (player.cmd.sidemove < 0)) and player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combatrole = 5
			player.weapondelay = 20
			S_StartSound(player.mo, sfx_wepchg)
		end
	end
end)

//choose again
addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.playerstate == PST_REBORN and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.crolechoosing = 5*TICRATE
		end
	end
end)

//Match Starts
addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.playerstate == PST_LIVE and player.crolechoosing == 16*TICRATE+1 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.pflags = $|PF_JUMPED
			P_SetObjectMomZ(player.mo, 5*FRACUNIT)
			S_StartSound(player.mo, sfx_jump)
			player.mo.state = S_PLAY_FALL
			if player.combatrole == 0
				local randomrole = P_RandomRange(1,6)
				if randomrole == 1
					player.combatrole = 1
					CONS_Printf(player, "Role remained unknown. Your assigned role is \x85 Melee.")
				elseif randomrole == 2
					player.combatrole = 2
					CONS_Printf(player, "Role remained unknown. Your assigned role is \x87 Shooter.")
				elseif randomrole == 3
					player.combatrole = 3
					CONS_Printf(player, "Role remained unknown. Your assigned role is \x84 Speedster.")
				elseif randomrole == 4
					player.combatrole = 4
					CONS_Printf(player, "Role remained unknown. Your assigned role is \x81 Tornado.")
				elseif randomrole == 5
					player.combatrole = 5
					CONS_Printf(player, "Role remained unknown. Your assigned role is \x88 Defender.")
				elseif randomrole == 6
					player.combatrole = 6
					CONS_Printf(player, "Role remained unknown. Your assigned role is \x86 Bomber.")
				end
			end
		end
	end
end)

//Choose again when moving to next round
addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.realtime == 1 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.crolechoosing = 10
		end
	end
end)

//Oh, you don't have an role?
addHook("ThinkFrame", function()
	for player in players.iterate do
		if (player.playerstate == PST_REBORN or player.jointime == 1) and player.combatrole == 0 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) and not (player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE) then
			local randomrole = P_RandomRange(1,6)
			if randomrole == 1
				player.combatrole = 1
				CONS_Printf(player, "Round already started. Your assigned role is \x85 Melee.")
			elseif randomrole == 2
				player.combatrole = 2
				CONS_Printf(player, "Round already started. Your assigned role is \x87 Shooter.")
			elseif randomrole == 3
				player.combatrole = 3
				CONS_Printf(player, "Round already started. Your assigned role is \x84 Speedster.")
			elseif randomrole == 4
				player.combatrole = 4
				CONS_Printf(player, "Round already started. Your assigned role is \x81 Tornado.")
			elseif randomrole == 5
				player.combatrole = 5
				CONS_Printf(player, "Round already started. Your assigned role is \x88 Defender.")
			elseif randomrole == 6
				player.combatrole = 6
				CONS_Printf(player, "Round already started. Your assigned role is \x86 Bomber.")
			end
		end
	end
end)

//When you played enough Combat
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if not ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.realability == 1
				player.charability = CA_THOK
			elseif player.realability == 2
				player.charability = CA_FLY
			elseif player.realability == 3
				player.charability = CA_GLIDEANDCLIMB
			elseif player.realability == 4
				player.charability = CA_TWINSPIN
			elseif player.realability == 5
				player.charability = CA_BOUNCE
			elseif player.realability == 6
				player.charability = CA_FLOAT
			elseif player.realability == 7
				player.charability = CA_SLOWFALL
			elseif player.realability == 8
				player.charability = CA_HOMINGTHOK
			elseif player.realability == 9
				player.charability = CA_AIRDRILL
			elseif player.realability == 10
				player.charability = CA_DOUBLEJUMP
			elseif player.realability == 11
				player.charability = CA_SWIM
			elseif player.realability == 12
				player.charability = CA_FALLSWITCH
			elseif player.realability == 13
				player.charability = CA_JUMPBOOST
			elseif player.realability == 14
				player.charability = CA_JUMPTHOK
			elseif player.realability == 15
				player.charability = CA_NONE
			end
			R_SetPlayerSkin(player, player.mo.skin)
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.realability2 == nil then
			if player.charability2 == CA2_SPINDASH
				player.realability2 = 1
			elseif player.charability2 == CA2_MELEE
				player.realability2 = 2
			elseif player.charability2 == CA2_GUNSLINGER
				player.realability2 = 3
			else
				player.realability2 = 20
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if not ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.realability2 == 1
				player.charability2 = CA2_SPINDASH
			elseif player.realability2 == 2
				player.charability2 = CA2_MELEE
			elseif player.realability2 == 3
				player.charability2 = CA2_GUNSLINGER
			else
				player.charability2 = CA2_NONE
			end
			R_SetPlayerSkin(player, player.mo.skin)
		end
	end
end)

local function hudstuff(v, player, cam)
	if (player.mo and player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)))
		v.drawString(82, 50, "Choose your Role with", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_REDMAP|V_PERPLAYER)
		v.drawString(72, 60, "Weapon Next and Weapon Prev", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_REDMAP|V_PERPLAYER)
		v.drawString(82, 70, "Press Fire to confirm", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_REDMAP|V_PERPLAYER)
		v.drawString(112, 80, "Role:", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_REDMAP|V_PERPLAYER)
		v.drawString(132, 100, "Time:" + player.crolechoosing + "/" + 16*TICRATE, V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_SKYMAP|V_PERPLAYER)
		if player.combatrole == 1
			v.drawString(153, 80, "Melee", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_REDMAP|V_PERPLAYER)
			v.drawString(23, 90, "Powerful Close-Ranged Attacks", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_REDMAP|V_PERPLAYER)
		elseif player.combatrole == 2
			v.drawString(153, 80, "Shooter", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_ORANGEMAP|V_PERPLAYER)
			v.drawString(33, 90, "Distantce Attacks", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_ORANGEMAP|V_PERPLAYER)
		elseif player.combatrole == 3
			v.drawString(153, 80, "Speedster", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_BLUEMAP|V_PERPLAYER)
			v.drawString(25, 90, "High Speed and Decent Mobility", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_BLUEMAP|V_PERPLAYER)
		elseif player.combatrole == 4
			v.drawString(153, 80, "Tornado", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_ROSYMAP|V_PERPLAYER)
			v.drawString(30, 90, "Awesome Offensive Manoeuvre", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_ROSYMAP|V_PERPLAYER)
		elseif player.combatrole == 5
			v.drawString(153, 80, "Defender", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_SKYMAP|V_PERPLAYER)
			v.drawString(35, 90, "Defensive abilities", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_SKYMAP|V_PERPLAYER)
		elseif player.combatrole == 6
			v.drawString(153, 80, "Bomber", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_GRAYMAP|V_PERPLAYER)
			v.drawString(17, 90, "Explosive damages with strong knockback", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_GRAYMAP|V_PERPLAYER)
		end
	end
end

hud.add(hudstuff, player)