//Slide
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 3 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.speed > 5*FRACUNIT and P_IsObjectOnGround(player.mo) and (player.cmd.buttons & BT_SPIN) and player.playerstate == PST_LIVE and not (player.pflags & PF_SPINNING)
				P_InstaThrust(player.mo, player.mo.angle, player.speed+5*FRACUNIT)
				S_StartSound(player.mo, sfx_spin)
				local hitbox = P_SpawnPlayerMissile(player.mo, MT_CHITBOX)
				P_KillMobj(hitbox)
				player.combatatk = 20
				player.mo.state = S_PLAY_ROLL
				player.pflags = $|PF_SPINNING
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 3 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.pflags & PF_SPINNING)
				local hitbox = P_SpawnPlayerMissile(player.mo, MT_CHITBOX)
				P_KillMobj(hitbox)
				player.combatatk = 20
				player.mo.state = S_PLAY_ROLL
			end
		end
	end
end)

//Bounce
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.cbounce == nil then
			player.cbounce = false
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.bouncedelay == nil then
			player.bouncedelay = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.bouncedelay > 0 and player.bouncedelay <= 10*TICRATE then
			player.bouncedelay = $-1
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.bouncedelay < 0 then
			player.bouncedelay = 0
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 3 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.pflags & PF_JUMPED) and player.playerstate == PST_LIVE and (player.cmd.buttons & BT_SPIN) and player.bouncedelay == 0 and player.cbounce == false and not (P_IsObjectOnGround(player.mo) or (player.pflags & PF_THOKKED) or ((player.cmd.buttons & BT_JUMP) and (player.cmd.buttons & BT_SPIN)))
				P_SetObjectMomZ(player.mo, -35*FRACUNIT)
				player.bouncedelay = 5*TICRATE
				local hitbox = P_SpawnPlayerMissile(player.mo, MT_CHITBOX)
				P_KillMobj(hitbox)
				S_StartSound(player.mo, sfx_zoom)
				player.mo.state = S_PLAY_ROLL
				player.cbounce = true
				player.combatatk = 22
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 3 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.cbounce == true and P_IsObjectOnGround(player.mo) and player.playerstate == PST_LIVE
				local hitbox = P_SpawnPlayerMissile(player.mo, MT_CHITBOX)
				P_KillMobj(hitbox)
				P_SetObjectMomZ(player.mo, 14*FRACUNIT)
				P_RadiusAttack(player.mo, player.mo, 130*FRACUNIT, DMG_NUKE, false)
				S_StartSound(player.mo, sfx_bnce1)
				player.mo.state = S_PLAY_SPRING
				player.cbounce = false
				player.combatatk = 26
				player.pflags = $|PF_JUMPED|PF_THOKKED
			end
		end
	end
end)

//Slash
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.cslash == nil then
			player.cslash = false
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if P_IsObjectOnGround(player.mo) then
			player.cslash = false
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.slashdelay == nil then
			player.slashdelay = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.slashdelay > 0 and player.slashdelay <= 10*TICRATE then
			player.slashdelay = $-1
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.slashdelay < 0 then
			player.slashdelay = 0
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 3 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.cmd.buttons & BT_JUMP) and (player.cmd.buttons & BT_SPIN) and player.slashdelay == 0 and player.cslash == false and player.playerstate == PST_LIVE
				P_Thrust(player.mo, player.mo.angle, -10*FRACUNIT)
				P_SetObjectMomZ(player.mo, 10*FRACUNIT)
				player.cslash = true
				player.slashdelay = 6*TICRATE
				player.mo.state = S_PLAY_SPINDASH
				local slash1 = P_SpawnPlayerMissile(player.mo, MT_SLASH)
				local slash2 = P_SpawnPlayerMissile(player.mo, MT_SLASH)
				local slash3 = P_SpawnPlayerMissile(player.mo, MT_SLASH)
				local slash4 = P_SpawnPlayerMissile(player.mo, MT_SLASH)
				local slash5 = P_SpawnPlayerMissile(player.mo, MT_SLASH)
				local slash6 = P_SpawnPlayerMissile(player.mo, MT_SLASH)
				slash1.color = player.mo.color
				slash2.color = player.mo.color
				slash3.color = player.mo.color
				slash4.color = player.mo.color
				slash5.color = player.mo.color
				slash6.color = player.mo.color
				slash1.name = "\x84 's Slash"
				slash2.name = "\x84 's Slash"
				slash3.name = "\x84 's Slash"
				slash4.name = "\x84 's Slash"
				slash5.name = "\x84 's Slash"
				slash6.name = "\x84 's Slash"
				P_InstaThrust(slash1, player.mo.angle, player.speed+6*FRACUNIT)
				P_InstaThrust(slash2, player.mo.angle, player.speed+13*FRACUNIT)
				P_InstaThrust(slash3, player.mo.angle, player.speed+20*FRACUNIT)
				P_InstaThrust(slash4, player.mo.angle, player.speed+26*FRACUNIT)
				P_InstaThrust(slash5, player.mo.angle, player.speed+32*FRACUNIT)
				P_InstaThrust(slash6, player.mo.angle, player.speed+40*FRACUNIT)
				S_StartSound(player.mo, sfx_trfire)
				player.combatatk = 20
			end
		end
	end
end)

//Boost
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 3 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.cmd.buttons & BT_CUSTOM1) and player.weapondelay == 0 and player.playerstate == PST_LIVE and not (P_PlayerInPain(player) or (player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE))
				P_InstaThrust(player.mo, player.mo.angle, 55*FRACUNIT)
				player.powers[pw_invulnerability] = 4
				S_StartSound(player.mo, sfx_zoom)
				player.combatatk = 30
				player.mo.state = S_PLAY_RUN
				player.weapondelay = 9*TICRATE
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 3 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.cmd.buttons & BT_CUSTOM1) and player.weapondelay >= 6*TICRATE and player.playerstate == PST_LIVE and player.weapondelay < 9*TICRATE and not (P_PlayerInPain(player) or (player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE))
				P_InstaThrust(player.mo, player.mo.angle, 50*FRACUNIT)
				local ghost = P_SpawnGhostMobj(player.mo)
				ghost.fuse = 4
				ghost.colorized = true
				player.combatatk = 30
				ghost.color = player.mo.color
				player.mo.state = S_PLAY_DASH
				player.charflags = $|SF_RUNONWATER
				player.powers[pw_invulnerability] = 5
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 3 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.weapondelay == 6*TICRATE
				player.mo.state = S_PLAY_STND
				R_SetPlayerSkin(player, player.mo.skin)
				player.charflags = $1 & ~SF_RUNONWATER
				player.powers[pw_invulnerability] = 1
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 3 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.normalspeed = 39*FRACUNIT
		end
	end
end)

//reset cooldown on respawn or on beginning of the round
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (player.realtime == 1 or player.playerstate == PST_REBORN) and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.slashdelay = 0
			player.bouncedelay = 0
		end
	end
end)

local function hudstuff(v, player, cam)
	if (player.mo and player.combatrole == 3 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)))
		v.drawString(12, 110, "Slash (S+J):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_BLUEMAP|V_PERPLAYER)
		v.drawString(12, 120, "Bounce (S air):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_BLUEMAP|V_PERPLAYER)
		v.drawString(12, 130, "Boost (Hold C1):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_BLUEMAP|V_PERPLAYER)
		v.drawFill(100, 110, player.slashdelay/4, 8, SKINCOLOR_BLUE)
		v.drawFill(122, 120, player.bouncedelay/4, 8, SKINCOLOR_COBALT)
		v.drawFill(132, 130, player.weapondelay/4, 8, SKINCOLOR_BLUE)
	end
end

hud.add(hudstuff, player)