//FFA Combat
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.fightercounted == nil and FightersAlive == nil then
			player.fightercounted = false
			FightersAlive = 0
		end
	end
end)

//Score = lives amount
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (gametype == GT_COMBATLIVES) then
			score = player.lives
		end
	end
end)


//Alive \('-')/
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (gametype == GT_COMBATLIVES) then
			if player.fightercounted == false and player.playerstate == PST_LIVE
				FightersAlive = $+1
				player.fightercounted = true
			end
		end
	end
end)

//Dead \(X_X)/
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (gametype == GT_COMBATLIVES) then
			if player.fightercounted == true and player.playerstate == PST_DEAD and player.lives == 0
				FightersAlive = $-1
				player.fightercounted = false
				player.lives = 0
				print("\x89"+ player.mo.name + "has lost all of their \x89 lives.")
			end
		end
	end
end)

//Round Ends
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (gametype == GT_COMBATLIVES) then
			if FightersAlive == 1 and player.realtime > 20*TICRATE
				player.pflags = $|PF_FINISHED
			end
		end
	end
end)

//Team Combat
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.redcounted == nil and RedAlive == nil and player.bluecounted == nil and BluedAlive == nil then
			player.redcounted = false
			RedAlive = 0
			player.bluecounted = false
			BlueAlive = 0
		end
	end
end)

//Teammate count
//Score = Teammate count
addHook("PlayerThink", function(player)
	if G_GametypeHasTeams()
		if (gametype == GT_TEAMCOMBATLIVES) then
			redscore = RedAlive
			bluescore = BlueAlive
		end
	end
end)

//Red
//Alive \('-')/
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (gametype == GT_TEAMCOMBATLIVES) then
			if player.ctfteam == 1 and player.redcounted == false and player.playerstate == PST_LIVE
				RedAlive = $+1
				player.redcounted = true
			end
		end
	end
end)

//Dead \(X_X)/
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (gametype == GT_TEAMCOMBATLIVES) then
			if player.ctfteam == 1 and player.redcounted == true and player.playerstate == PST_DEAD and player.lives == 0
				RedAlive = $-1
				player.redcounted = false
				player.lives = 0
				print("\x85"+ player.mo.name + "has lost all of their \x85 lives.")
			end
		end
	end
end)

//Blue
//Alive \('-')/
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (gametype == GT_TEAMCOMBATLIVES) then
			if player.ctfteam == 2 and player.bluecounted == false and player.playerstate == PST_LIVE
				BlueAlive = $+1
				player.bluecounted = true
			end
		end
	end
end)

//Dead \(X_X)/
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (gametype == GT_TEAMCOMBATLIVES) then
			if player.ctfteam == 2 and player.bluecounted == true and player.playerstate == PST_DEAD and player.lives == 0
				BlueAlive = $-1
				player.bluecounted = false
				player.lives = 0
				print("\x84"+ player.mo.name + "has lost all of their \x84 lives.")
			end
		end
	end
end)

//Round Ends
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (gametype == GT_TEAMCOMBATLIVES) then
			if (RedAlive == 0 or BlueAlive == 0) and player.realtime > 20*TICRATE
				player.pflags = $|PF_FINISHED
			end
		end
	end
end)