//Guard
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.cguardtimer == nil then
			player.cguardtimer = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.cguardtimer >= 3*TICRATE and not player.combatrole == 5 then
			player.cguardtimer = 3*TICRATE
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.state ~= S_PLAY_CGUARD then
			player.cguardtimer = $-2
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.cguardtimer < 0 then
			player.cguardtimer = 0
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (player.cmd.buttons & BT_FIRENORMAL) and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if P_IsObjectOnGround(player.mo) and not player.combatrole == 5
				player.mo.state = S_PLAY_CGUARD
				player.cguardtimer = $+1
				player.combatatk = 9
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (player.cmd.buttons & BT_FIRENORMAL) and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) and not player.crole == 5 then
			if player.cguardtimer <= 1*TICRATE+25 and P_IsObjectOnGround(player.mo) and not player.combatrole == 5
				if player.mo.state == S_PLAY_CGUARD
					local hitbox = P_SpawnPlayerMissile(player.mo, MT_CGUARDHITBOX)
					P_KillMobj(hitbox)
					player.powers[pw_strong] = STR_GUARD|STR_ANIM
				end
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.mo.state == S_PLAY_CGUARD and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if not (player.cmd.buttons & BT_FIRENORMAL)
				player.mo.state = S_PLAY_STND
			end
		end
	end
end)

//Aerial Dodge
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatdodge == nil then
			player.combatdodge = false
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if P_IsObjectOnGround(player.mo) then
			player.combatdodge = false
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (player.cmd.buttons & BT_FIRENORMAL) and player.combatdodge == false and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if not P_IsObjectOnGround(player.mo)
				P_InstaThrust(player.mo, player.mo.angle, 5*FRACUNIT)
				P_SetObjectMomZ(player.mo, 4*FRACUNIT)
				S_StartSound(player.mo, sfx_wdjump)
				player.mo.state = S_PLAY_ROLL
				player.combatdodge = true
				player.powers[pw_flashing] = 10
			end
		end
	end
end)

//Defender's Effective Guarding
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.cguardtimer >= 5*TICRATE and player.crole == 5 then
			player.cguardtimer = 5*TICRATE
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (player.cmd.buttons & BT_FIRENORMAL) and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if P_IsObjectOnGround(player.mo) and player.crole == 5
				player.mo.state = S_PLAY_CGUARD
				player.cguardtimer = $+1
				player.combatatk = 11
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (player.cmd.buttons & BT_FIRENORMAL) and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) and player.crole == 5 then
			if player.cguardtimer <= 3*TICRATE+25 and P_IsObjectOnGround(player.mo)
				if player.mo.state == S_PLAY_CGUARD
					local hitbox = P_SpawnPlayerMissile(player.mo, MT_CGUARDHITBOX)
					P_KillMobj(hitbox)
					player.powers[pw_strong] = STR_GUARD|STR_ANIM
				end
			end
		end
	end
end)
