//Bomb Hold
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.bholddelay == nil then
			player.bholddelay = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.bholddelay > 0 and player.bholddelay <= 25*TICRATE then
			player.bholddelay = $-1
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.bholddelay < 0 then
			player.bholddelay = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.holdingbomb == nil and player.bombtimer == nil and player.bombed == nil and player.maxbombtimer == nil then
			player.holdingbomb = false
			player.bombtimer = 0
			player.bombed = false
			player.maxbombtimer = 5*TICRATE+3
        end
    end
end)

//Creating Bomb
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.combatrole == 6 and (player.cmd.buttons & BT_SPIN) and player.bholddelay == 0 and player.holdingbomb == false and player.weapondelay == 0*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) and player.playerstate == PST_LIVE
			player.bombtimer = 5*TICRATE
			player.bholddelay = 15*TICRATE --behold, the bomb
			player.holdingbomb = true
			player.weapondelay = 20
		end
	end
end)

//Holding Bomb
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.combatrole == 6 and player.holdingbomb == true and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) and player.playerstate == PST_LIVE
			player.bombtimer = $-1
			player.holdingbomb = true
			S_StartSound(player.mo, sfx_s3k43)
		end
	end
end)

//Explode Bomb
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.combatrole == 6 and (player.cmd.buttons & BT_SPIN) and player.holdingbomb == true and player.bombtimer > 0 and player.weapondelay == 0*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) and player.playerstate == PST_LIVE
			player.mo.state = S_PLAY_GASP
			player.bombtimer = 1
			player.combatatk = 30
		end
	end
end)

//Bomb Explodes

//1.by time
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.combatrole == 6 and player.bombtimer == 0 and player.holdingbomb == true and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF))
			P_NukeEnemies(player.mo, player.mo, 210*FRACUNIT)
			P_Thrust(player.mo, player.mo.angle, 15*FRACUNIT)
			P_SetObjectMomZ(player.mo, 11*FRACUNIT)
			local bombhold = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
			P_KillMobj(bombhold)
			P_StartQuake(10*FRACUNIT, 10)
			S_StartSound(player.mo, sfx_bkpoof)
			player.mo.state = S_PLAY_PAIN
			player.powers[pw_flashing] = 2
			player.bholddelay = 10*TICRATE
			player.bombtimer = 0
			player.bombed = true
			player.combatatk = 32
		end
	end
end)

//2.by pain
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.combatrole == 6 and (P_PlayerInPain(player) or player.playerstate == PST_DEAD) and player.holdingbomb == true and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF))
			local bombhold = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
			P_KillMobj(bombhold)
			P_NukeEnemies(player.mo, player.mo, 210*FRACUNIT)
			P_SetObjectMomZ(player.mo, 15*FRACUNIT)
			P_Thrust(player.mo, player.mo.angle, 2*FRACUNIT)
			P_StartQuake(10*FRACUNIT, 10)
			S_StartSound(player.mo, sfx_bkpoof)
			player.bholddelay = 10*TICRATE
			player.mo.state = S_PLAY_PAIN
			player.holdingbomb = false
			player.bombtimer = 0
			player.bombed = true
			player.combatatk = 32
		end
	end
end)

//effects
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.combatrole == 6 and player.bombed == true and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF))
			P_SpawnPlayerMissile(player.mo, MT_SMOKE)
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.combatrole == 6 and P_IsObjectOnGround(player.mo) and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF))
			player.bombed = false
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.combatrole == 6 and player.holdingbomb == true and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF))
			local bombhold = P_SpawnPlayerMissile(player.mo, MT_BOMBHOLD)
			P_KillMobj(bombhold)
		end
	end
end)

//Bomb Drop
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 6 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.cmd.buttons & BT_CUSTOM1) and player.bdropdelay == 0 and not (P_IsObjectOnGround(player.mo) or P_PlayerInPain(player) or (player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE) or player.playerstate == PST_DEAD)
				local bomb1 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				local bomb2 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				local bomb3 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				local bomb4 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				local bomb5 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				local bomb6 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				local bomb7 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				local bomb8 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				local bomb9 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				local bomb10 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				local bomb11 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				local bomb12 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				bomb1.name = "\x86 's Bomb"
				bomb2.name = "\x86 's Bomb"
				bomb3.name = "\x86 's Bomb"
				P_SetObjectMomZ(bomb1, -20*FRACUNIT)
				P_InstaThrust(bomb1, player.mo.angle, 0*FRACUNIT)
				P_SetObjectMomZ(bomb2, -20*FRACUNIT)
				P_InstaThrust(bomb2, player.mo.angle, -30*FRACUNIT)
				P_Thrust(bomb2, player.mo.angle - ANGLE_45, -2*FRACUNIT)
				P_SetObjectMomZ(bomb3, -20*FRACUNIT)
				P_InstaThrust(bomb3, player.mo.angle, 0*FRACUNIT)
				P_Thrust(bomb3, player.mo.angle + ANGLE_45, 10*FRACUNIT)
				P_SetObjectMomZ(bomb4, -20*FRACUNIT)
				P_InstaThrust(bomb4, player.mo.angle, 15*FRACUNIT)
				P_SetObjectMomZ(bomb5, -20*FRACUNIT)
				P_InstaThrust(bomb5, player.mo.angle, -10*FRACUNIT)
				P_Thrust(bomb6, player.mo.angle, 15*FRACUNIT)
				P_SetObjectMomZ(bomb6, -20*FRACUNIT)
				P_InstaThrust(bomb6, player.mo.angle, -5*FRACUNIT)
				P_Thrust(bomb6, player.mo.angle, -20*FRACUNIT)
				P_SetObjectMomZ(bomb7, 8*FRACUNIT)
				P_SetObjectMomZ(bomb8, 8*FRACUNIT)
				P_SetObjectMomZ(bomb9, 8*FRACUNIT)
				P_InstaThrust(bomb7, player.mo.angle - ANGLE_45, player.speed + 6*FRACUNIT)
				P_InstaThrust(bomb8, player.mo.angle, player.speed + 10*FRACUNIT)
				P_InstaThrust(bomb9, player.mo.angle + ANGLE_45, player.speed + 6*FRACUNIT)
				P_SetObjectMomZ(bomb10, 3*FRACUNIT)
				P_SetObjectMomZ(bomb11, 3*FRACUNIT)
				P_SetObjectMomZ(bomb12, 3*FRACUNIT)
				P_InstaThrust(bomb10, player.mo.angle - ANGLE_45, player.speed + 3*FRACUNIT)
				P_InstaThrust(bomb11, player.mo.angle, player.speed + 5*FRACUNIT)
				P_InstaThrust(bomb12, player.mo.angle + ANGLE_45, player.speed + 3*FRACUNIT)
				player.bdropdelay = 2*TICRATE
				player.combatatk = 20
			end
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.bdropdelay == nil then
			player.bdropdelay = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.bdropdelay > 0 and player.bdropdelay <= 25*TICRATE then
			player.bdropdelay = $-1
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.bdropdelay < 0 then
			player.bdropdelay = 0
		end
	end
end)

//Bomb Toss
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 6 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.cmd.buttons & BT_CUSTOM1) and player.weapondelay == 0 and P_IsObjectOnGround(player.mo) and not (P_PlayerInPain(player) or (player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE) or player.playerstate == PST_DEAD)
				local bomb1 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				local bomb2 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				local bomb3 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				local bomb4 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				local bomb5 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				local bomb6 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				P_SetObjectMomZ(bomb1, 8*FRACUNIT)
				P_SetObjectMomZ(bomb2, 8*FRACUNIT)
				P_SetObjectMomZ(bomb3, 8*FRACUNIT)
				P_InstaThrust(bomb1, player.mo.angle - ANGLE_45, player.speed + 6*FRACUNIT)
				P_InstaThrust(bomb2, player.mo.angle, player.speed + 10*FRACUNIT)
				P_InstaThrust(bomb3, player.mo.angle + ANGLE_45, player.speed + 6*FRACUNIT)
				P_SetObjectMomZ(bomb4, 3*FRACUNIT)
				P_SetObjectMomZ(bomb5, 3*FRACUNIT)
				P_SetObjectMomZ(bomb6, 3*FRACUNIT)
				P_InstaThrust(bomb4, player.mo.angle - ANGLE_45, player.speed + 3*FRACUNIT)
				P_InstaThrust(bomb5, player.mo.angle, player.speed + 5*FRACUNIT)
				P_InstaThrust(bomb6, player.mo.angle + ANGLE_45, player.speed + 3*FRACUNIT)
				player.mo.state = S_PLAY_GASP
				player.weapondelay =  2*TICRATE+15
				player.combatatk = 20
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 6 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.mo.state == S_PLAY_GASP and player.weapondelay == 2*TICRATE and player.playerstate == PST_LIVE
				local bomb1 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				local bomb2 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				local bomb3 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				bomb1.name = "\x86 's Bomb"
				bomb2.name = "\x86 's Bomb"
				bomb3.name = "\x86 's Bomb"
				P_SetObjectMomZ(bomb1, 8*FRACUNIT)
				P_SetObjectMomZ(bomb2, 8*FRACUNIT)
				P_SetObjectMomZ(bomb3, 8*FRACUNIT)
				P_InstaThrust(bomb1, player.mo.angle - ANGLE_45, player.speed + 6*FRACUNIT)
				P_InstaThrust(bomb2, player.mo.angle, player.speed + 10*FRACUNIT)
				P_InstaThrust(bomb3, player.mo.angle + ANGLE_45, player.speed + 6*FRACUNIT)
				player.mo.state = S_PLAY_GASP
				player.combatatk = 20
			end
		end
	end
end)

//Explosion
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 6 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.cmd.buttons & BT_CUSTOM2) and player.explodedelay == 0 and player.playerstate == PST_LIVE and not (P_PlayerInPain(player) or (player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE))
				player.mo.state = S_PLAY_SUPER_TRANS6
				S_StartSound(player.mo, sfx_bkpoof)
				local bomb1 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				local bomb2 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				local bomb3 = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				bomb1.name = "\x86 's Explosion"
				bomb2.name = "\x86 's Explosion"
				bomb3.name = "\x86 's Explosion"
				P_KillMobj(bomb1)
				P_KillMobj(bomb2)
				P_KillMobj(bomb3)
				P_NukeEnemies(player.mo, player.mo, 320*FRACUNIT)
				P_RadiusAttack(player.mo, player.mo, 320*FRACUNIT, DMG_NUKE, true)
				player.explodedelay = 10*TICRATE
				player.combatatk = 34
			end
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.explodedelay == nil then
			player.explodedelay = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.explodedelay > 0 and player.explodedelay <= 25*TICRATE then
			player.explodedelay = $-1
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.explodedelay < 0 then
			player.explodedelay = 0
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 6 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.normalspeed = 37*FRACUNIT
		end
	end
end)

//reset cooldown on respawn or on beginning of the round
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (player.realtime == 1 or player.playerstate == PST_REBORN) and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.bholddelay = 0
			player.bdropdelay = 0
			player.explodedelay = 0
		end
	end
end)

local function hudstuff(v, player, cam)
	if (player.mo and player.combatrole == 6 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)))
		v.drawString(12, 110, "Bomb Hold (S):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_GRAYMAP|V_PERPLAYER)
		v.drawFill(135, 110, player.bholddelay/4, 8, SKINCOLOR_PURPLE)
		v.drawString(12, 140, "Bomb Drop (C1 air):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PURPLEMAP|V_PERPLAYER)
		v.drawFill(145, 140, player.bdropdelay/4, 8, SKINCOLOR_PURPLE)
		v.drawString(12, 130, "Bomb Toss (C1 ground):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_GRAYMAP|V_PERPLAYER)
		v.drawFill(162, 130, player.weapondelay/4, 8, SKINCOLOR_PURPLE)
		v.drawString(12, 120, "Explosion (C2):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PURPLEMAP|V_PERPLAYER)
		v.drawFill(135, 120, player.explodedelay/4, 8, SKINCOLOR_PURPLE)
	end
end

hud.add(hudstuff, player)

local function hudstuff(v, player, cam)
	if player.combatrole == 6 and player.holdingbomb == true
		v.drawFill(179, 129, player.maxbombtimer/3, 10, SKINCOLOR_BLACK)
		v.drawFill(180, 130, player.bombtimer/3, 8, SKINCOLOR_RED)
	end
end

hud.add(hudstuff, player)