//Tackle
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 2 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.cmd.buttons & BT_SPIN) and player.weapondelay == 0 and P_IsObjectOnGround(player.mo) and player.playerstate == PST_LIVE
				player.weapondelay = 1*TICRATE
				player.mo.state = S_PLAY_TACKLE1
				player.combatatk = 10
				S_StartSound(player.mo, sfx_spin)
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 2 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.mo.state == S_PLAY_TACKLE1 or player.mo.state == S_PLAY_TACKLE2 or player.mo.state == S_PLAY_TACKLE3 or player.mo.state == S_PLAY_TACKLE4 or player.mo.state == S_PLAY_TACKLE5
				P_SpawnGhostMobj(player.mo)
				local hitbox = P_SpawnPlayerMissile(player.mo, MT_CHITBOX)
				P_KillMobj(hitbox)
				player.powers[pw_strong] = STR_ATTACK|STR_WALL|STR_ANIM
				player.combatatk = 10
			end
		end
	end
end)

//Missiles
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.cmissiledelay == nil then
			player.cmissiledelay = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.cmissiledelay > 0 and player.cmissiledelay <= 10*TICRATE then
			player.cmissiledelay = $-1
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.cmissiledelay < 0 then
			player.cmissiledelay = 0
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 2 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.cmd.buttons & BT_CUSTOM2) and player.cmissiledelay == 0*TICRATE and player.playerstate == PST_LIVE and not (P_PlayerInPain(player) or (player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE))
				player.cmissiledelay = 7*TICRATE
				player.combatatk = 9
				local missile1 = P_SpawnPlayerMissile(player.mo, MT_ROCKET)
				local missile2 = P_SpawnPlayerMissile(player.mo, MT_ROCKET)
				local missile3 = P_SpawnPlayerMissile(player.mo, MT_ROCKET)
				local missile4 = P_SpawnPlayerMissile(player.mo, MT_ROCKET)
				local missile5 = P_SpawnPlayerMissile(player.mo, MT_ROCKET)
				local missile6 = P_SpawnPlayerMissile(player.mo, MT_ROCKET)
				local missile7 = P_SpawnPlayerMissile(player.mo, MT_ROCKET)
				missile1.colorized = true
				missile2.colorized = true
				missile3.colorized = true
				missile4.colorized = true
				missile5.colorized = true
				missile6.colorized = true
				missile7.colorized = true
				missile1.color = player.mo.color
				missile2.color = player.mo.color
				missile3.color = player.mo.color
				missile4.color = player.mo.color
				missile5.color = player.mo.color
				missile6.color = player.mo.color
				missile7.color = player.mo.color
				missile1.name = "\x87 's Missile"
				missile2.name = "\x87 's Missile"
				missile3.name = "\x87 's Missile"
				missile4.name = "\x87 's Missile"
				missile5.name = "\x87 's Missile"
				missile6.name = "\x87 's Missile"
				missile7.name = "\x87 's Missile"
				P_InstaThrust(missile1, player.mo.angle - ANG30, player.speed + 29*FRACUNIT)
				P_InstaThrust(missile2, player.mo.angle, player.speed + 28*FRACUNIT)
				P_InstaThrust(missile3, player.mo.angle + ANG30, player.speed + 29*FRACUNIT)
				P_InstaThrust(missile4, player.mo.angle - ANGLE_45, player.speed + 29*FRACUNIT)
				P_InstaThrust(missile5, player.mo.angle + ANGLE_45, player.speed + 29*FRACUNIT)
				P_InstaThrust(missile6, player.mo.angle - ANG15, player.speed + 29*FRACUNIT)
				P_InstaThrust(missile7, player.mo.angle + ANG15, player.speed + 29*FRACUNIT)		
				S_StartSound(player.mo, sfx_spin)
			end
		end
	end
end)

//Bomb Attack
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.cbombdelay == nil then
			player.cbombdelay = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.cbombdelay > 0 and player.cbombdelay <= 10*TICRATE then
			player.cbombdelay = $-1
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.cbombdelay < 0 then
			player.cbombdelay = 0
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 2 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.cmd.buttons & BT_CUSTOM1) and player.cbombdelay == 0 and player.playerstate == PST_LIVE and not (P_PlayerInPain(player) or (player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE))
				player.cbombdelay = 8*TICRATE
				player.mo.state = S_PLAY_GASP
				P_SetObjectMomZ(player.mo, 5*FRACUNIT)
				player.combatatk = 25
				local cmissile1 = P_SpawnPlayerMissile(player.mo, MT_THROWNEXPLOSION)
				local cmissile2 = P_SpawnPlayerMissile(player.mo, MT_THROWNEXPLOSION)
				local cmissile3 = P_SpawnPlayerMissile(player.mo, MT_THROWNEXPLOSION)
				local cmissile4 = P_SpawnPlayerMissile(player.mo, MT_THROWNEXPLOSION)
				P_SetObjectMomZ(cmissile1, -50*FRACUNIT)
				P_InstaThrust(cmissile2, player.mo.angle - ANGLE_270, 10*FRACUNIT)
				P_SetObjectMomZ(cmissile2, -50*FRACUNIT)
				P_InstaThrust(cmissile3, player.mo.angle - ANGLE_90, 13*FRACUNIT)
				P_SetObjectMomZ(cmissile3, -50*FRACUNIT)
				P_InstaThrust(cmissile4, player.mo.angle - ANGLE_180, 15*FRACUNIT)
				P_SetObjectMomZ(cmissile4, -50*FRACUNIT)
			end
		end
	end
end)

//Laser
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.laserdelay == nil then
			player.laserdelay = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.laserdelay > 0 and player.laserdelay <= 40*TICRATE then
			player.laserdelay = $-1
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.laserdelay < 0 then
			player.laserdelay = 0
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 2 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.cmd.buttons & BT_CUSTOM3) and player.laserdelay == 0 and player.playerstate == PST_LIVE and not (P_PlayerInPain(player) or (player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE))
				player.laserdelay = 25*TICRATE
				player.mo.state = S_PLAY_SPRING
				player.mo.momx = 0
				player.mo.momy = 0
				S_StartSound(player.mo, sfx_thok)
				P_SetObjectMomZ(player.mo, 5*FRACUNIT)
				player.combatatk = 10
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 2 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.laserdelay > 23*TICRATE-15
				player.mo.state = S_PLAY_GASP
				player.mo.momx = 0
				player.mo.momy = 0
				player.mo.momz = 0
				player.powers[pw_invulnerability] = 20
				player.combatatk = 10
				local laser1 = P_SpawnPlayerMissile(player.mo, MT_ROCKET)
				local laser2 = P_SpawnMobjFromMobj(player.mo, 15*FRACUNIT, 3*FRACUNIT, 0, MT_ROCKET)
				local laser3 = P_SpawnMobjFromMobj(player.mo, 15*FRACUNIT, 13*FRACUNIT, 0, MT_ROCKET)
				local laser4 = P_SpawnMobjFromMobj(player.mo, 10*FRACUNIT, 13*FRACUNIT, 0, MT_ROCKET)
				local laser5 = P_SpawnMobjFromMobj(player.mo, 5*FRACUNIT, 23*FRACUNIT, 0, MT_ROCKET)
				laser1.colorized = true
				laser2.colorized = true
				laser3.colorized = true
				laser4.colorized = true
				laser5.colorized = true
				laser1.color = player.mo.color
				laser2.color = player.mo.color
				laser3.color = player.mo.color
				laser4.color = player.mo.color
				laser5.color = player.mo.color
				laser1.name = "\x87 's Laser"
				laser2.name = "\x87 's Laser"
				laser3.name = "\x87 's Laser"
				laser4.name = "\x87 's Laser"
				laser5.name = "\x87 's Laser"
				laser1.drawangle = player.mo.angle
				laser2.drawangle = player.mo.angle
				laser3.drawangle = player.mo.angle
				laser4.drawangle = player.mo.angle
				laser5.drawangle = player.mo.angle
				P_InstaThrust(laser1, player.mo.angle, player.speed + 30*FRACUNIT)
				P_InstaThrust(laser2, player.mo.angle, player.speed + 25*FRACUNIT)
				P_InstaThrust(laser3, player.mo.angle, player.speed + 15*FRACUNIT)
				P_InstaThrust(laser4, player.mo.angle, player.speed + 7*FRACUNIT)
				P_InstaThrust(laser5, player.mo.angle, player.speed + 20*FRACUNIT)
				S_StartSound(player.mo, sfx_trfire)
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 2 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.normalspeed = 36*FRACUNIT
		end
	end
end)

//reset cooldown on respawn or on beginning of the round
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (player.realtime == 1 or player.playerstate == PST_REBORN) and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.cbombdelay = 0
			player.cmissiledelay = 0
			player.laserdelay = 0
		end
	end
end)

//Additional Huds
local function hudstuff(v, player, cam)
	if (player.mo and player.combatrole == 2 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)))
		v.drawString(12, 110, "Tackle (S):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_ORANGEMAP|V_PERPLAYER)
		v.drawFill(120, 110, player.weapondelay/4, 8, SKINCOLOR_ORANGE)
		v.drawString(12, 120, "Bomb Attack (C1):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_REDMAP|V_PERPLAYER)
		v.drawFill(120, 120, player.cbombdelay/4, 8, SKINCOLOR_RED)
		v.drawString(12, 130, "Missiles (C2):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_ORANGEMAP|V_PERPLAYER)
		v.drawFill(145, 130, player.cmissiledelay/4, 8, SKINCOLOR_ORANGE)
		v.drawString(12, 140, "Laser (C3):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_REDMAP|V_PERPLAYER)
		v.drawFill(125, 140, player.laserdelay/4, 8, SKINCOLOR_RED)
	end
end

hud.add(hudstuff, player)