//Tornado Spin
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 4 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.cmd.buttons & BT_SPIN) and player.weapondelay == 0*TICRATE and not (player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE)
				player.weapondelay = 3*TICRATE
				player.mo.state = S_PLAY_TORNADO
				player.combatatk = 12
				local hitbox = P_SpawnPlayerMissile(player.mo, MT_CBHITBOX)
				P_KillMobj(hitbox)
				S_StartSound(player.mo, sfx_wdjump)
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 4 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.weapondelay > 3*TICRATE-20 and player.playerstate == PST_LIVE
				if player.mo.state == S_PLAY_TORNADO
					player.combatatk = 12
					P_InstaThrust(player.mo, player.mo.angle, 43*FRACUNIT)
					P_SetObjectMomZ(player.mo, FRACUNIT/2)
					local tornadospin = P_SpawnPlayerMissile(player.mo, MT_TORNADOSPIN)
					local hitbox = P_SpawnPlayerMissile(player.mo, MT_CBHITBOX)
					tornadospin.color = player.mo.color
					P_KillMobj(tornadospin)
					P_KillMobj(hitbox)
					player.drawangle = $ - ANGLE_45
					player.powers[pw_strong] = STR_GUARD|STR_ATTACK|STR_WALL|STR_FLOOR|STR_CEILING|STR_ANIM
				end
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 4 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.weapondelay == 3*TICRATE-20 or player.weapondelay == 3*TICRATE-19
				player.mo.momx = 0
				player.mo.mmy = 0
			end
		end
	end
end)

//Tornado Swipe
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.tswipedelay == nil then
			player.tswipedelay = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.tswipedelay > 0 and player.tornadodelay <= 25*TICRATE then
			player.tswipedelay = $-1
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.tswipedelay < 0 then
			player.tswipedelay = 0
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 4 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.cmd.buttons & BT_CUSTOM1) and player.tswipedelay == 0 and not (P_PlayerInPain(player) or (player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE) or player.playerstate == PST_DEAD)
				player.tswipedelay = 8*TICRATE
				player.mo.state = S_PLAY_TORNADO
				player.combatatk = 14
				local swipetornado1 = P_SpawnPlayerMissile(player.mo, MT_TORNADOSWIPE)
				local swipetornado2 = P_SpawnPlayerMissile(player.mo, MT_TORNADOSWIPE)
				local swipetornado3 = P_SpawnPlayerMissile(player.mo, MT_TORNADOSWIPE)
				swipetornado1.name = "\x81 's Tornado Swipe"
				swipetornado2.name = "\x81 's Tornado Swipe"
				swipetornado3.name = "\x81 's Tornado Swipe"
				S_StartSound(player.mo, sfx_wdjump)
				P_InstaThrust(swipetornado1, player.mo.angle, player.speed + 15*FRACUNIT)
				P_Thrust(swipetornado1, player.mo.angle - ANGLE_45, 5*FRACUNIT)
				P_InstaThrust(swipetornado2, player.mo.angle, player.speed + 15*FRACUNIT)
				P_Thrust(swipetornado3, player.mo.angle + ANGLE_45, 5*FRACUNIT)
				P_InstaThrust(swipetornado3, player.mo.angle, player.speed + 15*FRACUNIT)
				swipetornado1.color = player.mo.color
				swipetornado2.color = player.mo.color
				swipetornado3.color = player.mo.color
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 4 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.mo.state == S_PLAY_TORNADO
				player.drawangle = $ - ANGLE_45
			end
		end
	end
end)

//Tornado Attract
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.tornadodelay == nil then
			player.tornadodelay = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.tornadodelay > 0 and player.tornadodelay <= 25*TICRATE then
			player.tornadodelay = $-1
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.tornadodelay < 0 then
			player.tornadodelay = 0
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 4 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.cmd.buttons & BT_CUSTOM2) and player.tornadodelay == 0 and not (P_PlayerInPain(player) or (player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE) or player.playerstate == PST_DEAD)
				player.tornadodelay = 24*TICRATE
				P_SetObjectMomZ(player.mo, 3*FRACUNIT)
				player.charability = CA_TELEKINESIS
				player.weapondelay = 4*TICRATE
				player.tswipedelay = 4*TICRATE
				player.mo.state = S_PLAY_GASP
				player.combatatk = 10
				S_StartSound(player.mo, sfx_wdjump)
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 4 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.tornadodelay > 19*TICRATE
				if player.mo.state == S_PLAY_GASP
					player.charability = CA_TELEKINESIS --to be able to pull in nearby opponents
					P_InstaThrust(player.mo, player.mo.angle, 20*FRACUNIT)
					player.mo.state = S_PLAY_GASP
					player.drawangle = $- ANGLE_45
					player.mo.momz = 0*FRACUNIT
					player.combatatk = 10
					P_Telekinesis(player, -15*FRACUNIT, 230*FRACUNIT)
					local supertornado = P_SpawnPlayerMissile(player.mo, MT_TORNADOATTRACT)
					supertornado.color = player.mo.color
					local tornado1 = P_SpawnPlayerMissile(player.mo, MT_CSPRINGHITBOX)
					local tornado2 = P_SpawnPlayerMissile(player.mo, MT_CSPRINGHITBOX)
					local tornado3 = P_SpawnPlayerMissile(player.mo, MT_CSPRINGHITBOX)
					local tornado4 = P_SpawnPlayerMissile(player.mo, MT_CSPRINGHITBOX)
					P_KillMobj(tornado1)
					P_KillMobj(tornado2)
					P_KillMobj(tornado3)
					P_KillMobj(tornado4)
					P_KillMobj(supertornado)
					S_StartSound(player.mo, sfx_spin)
					player.powers[pw_strong] = STR_GUARD|STR_ATTACK|STR_WALL|STR_FLOOR|STR_CEILING|STR_ANIM
				end
			end
		end
	end
end)

//Get your ability back
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.realability == nil and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.charability == CA_THOK
				player.realability = 1
			elseif player.charability == CA_FLY
				player.realability = 2
			elseif player.charability == CA_GLIDEANDCLIMB
				player.realability = 3
			elseif player.charability == CA_TWINSPIN
				player.realability = 4
			elseif player.charability == CA_BOUNCE
				player.realability = 5
			elseif player.charability == CA_FLOAT
				player.realability = 6
			elseif player.charability == CA_SLOWFALL
				player.realability = 7
			elseif player.charability == CA_HOMINGTHOK
				player.realability = 8
			elseif player.charability == CA_AIRDRILL
				player.realability = 9
			elseif player.charability == CA_DOUBLEJUMP
				player.realability = 10
			elseif player.charability == CA_SWIM
				player.realability = 11
			elseif player.charability == CA_FALLSWITCH
				player.realability = 12
			elseif player.charability == CA_JUMPBOOST
				player.realability = 13
			elseif player.charability == CA_JUMPTHOK
				player.realability = 14
			elseif player.charability == CA_TELEKINESIS
				player.realability = 15
			end
			R_SetPlayerSkin(player, player.mo.skin)
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 4 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.tornadodelay == 18*TICRATE
				if player.realability == 1
					player.charability = CA_THOK
				elseif player.realability == 2
					player.charability = CA_FLY
				elseif player.realability == 3
					player.charability = CA_GLIDEANDCLIMB
				elseif player.realability == 4
					player.charability = CA_TWINSPIN
				elseif player.realability == 5
					player.charability = CA_BOUNCE
				elseif player.realability == 6
					player.charability = CA_FLOAT
				elseif player.realability == 7
					player.charability = CA_SLOWFALL
				elseif player.realability == 8
					player.charability = CA_HOMINGTHOK
				elseif player.realability == 9
					player.charability = CA_AIRDRILL
				elseif player.realability == 10
					player.charability = CA_DOUBLEJUMP
				elseif player.realability == 11
					player.charability = CA_SWIM
				elseif player.realability == 12
					player.charability = CA_FALLSWITCH
				elseif player.realability == 13
					player.charability = CA_JUMPBOOST
				elseif player.realability == 14
					player.charability = CA_JUMPTHOK
				elseif player.realability == 15
					player.charability = CA_NONE
				end
				R_SetPlayerSkin(player, player.mo.skin)
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 5 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.normalspeed = 38*FRACUNIT
		end
	end
end)

//reset cooldown on respawn or on beginning of the round
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (player.realtime == 1 or player.playerstate == PST_REBORN) and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.tornadodelay = 0
			player.tswipedelay = 0
		end
	end
end)

local function hudstuff(v, player, cam)
	if (player.mo and player.combatrole == 4 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)))
		v.drawString(12, 120, "Tornado Attract(C2):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_ROSYMAP|V_PERPLAYER)
		v.drawString(12, 130, "Tornado Spin(S):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_ROSYMAP|V_PERPLAYER)
		v.drawString(12, 140, "Tornado Swipe (C1):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_ROSYMAP|V_PERPLAYER)
		v.drawFill(180, 120, player.tornadodelay/4, 8, SKINCOLOR_ROSY)
		v.drawFill(140, 130, player.weapondelay/4, 8, SKINCOLOR_PINK)
		v.drawFill(155, 140, player.tswipedelay/4, 8, SKINCOLOR_ROSY)
	end
end

hud.add(hudstuff, player)